package cn.iocoder.yudao.module.member.service.activityvoucheruser;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activityvoucheruser.vo.ActivityVoucherUserPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activityvoucheruser.vo.ActivityVoucherUserSaveReqVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.ActivityVoucherVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppActivityVoucherUserRespVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activityvoucheruser.ActivityVoucherUserDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 活动用户拥有代金券 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityVoucherUserService {

    /**
     * 创建活动用户拥有代金券
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityVoucherUser(@Valid ActivityVoucherUserSaveReqVO createReqVO);

    /**
     * 更新活动用户拥有代金券
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityVoucherUser(@Valid ActivityVoucherUserSaveReqVO updateReqVO);

    /**
     * 删除活动用户拥有代金券
     *
     * @param id 编号
     */
    void deleteActivityVoucherUser(Long id);

    /**
     * 获得活动用户拥有代金券
     *
     * @param id 编号
     * @return 活动用户拥有代金券
     */
    ActivityVoucherUserDO getActivityVoucherUser(Long id);

    /**
     * 获得活动用户拥有代金券分页
     *
     * @param pageReqVO 分页查询
     * @return 活动用户拥有代金券分页
     */
    PageResult<ActivityVoucherUserDO> getActivityVoucherUserPage(ActivityVoucherUserPageReqVO pageReqVO);

    PageResult<AppActivityVoucherUserRespVO> getActivityVoucherPage(ActivityVoucherUserPageReqVO pageReqVO);

    List<AppActivityVoucherUserRespVO> getActivityVoucherList(ActivityVoucherUserPageReqVO pageReqVO);

    Boolean checkVoucher(ActivityVoucherVO vo);

    void updateByVoucherIdAndUserId(Long id);

    void updateByIds(List<String> ids);

    List<ActivityVoucherUserDO> getListByIds(List<String> ids);
}